#version 330

in vec2 texCoord;

uniform sampler2D texUnit;

out vec4 outputF;

//----------------------------------------------------------------
// TODO:
// 1) Remember the blur code from the Image examples.
// 2) Load 25 neighbouring texture samples and compute their percieved luminance.
// 3) Calculate weighed color of the region (blur the luminances).
// 3) Use exposure to compute the tonemapped color.
//----------------------------------------------------------------
 
void main()
{
	ivec2 ofs;
	float lum[25];
	// Compute the scale of the offset to the neighbour
	vec2 scale = vec2(1.f) / textureSize(texUnit, 0);

	// Check 25 neighbours
	for(ofs.y = -2; ofs.y <= 2; ofs.y++)
	{
		for(ofs.x = -2; ofs.x <= 2; ofs.x++)
		{

			lum[(ofs.y+2)*5+(ofs.x+2)] = dot(col, vec3(0.30f, 0.59f, 0.11f));
		}
	}

	float weights[25] = float[25](1.f, 4.f, 7.f, 4.f, 1.f,
								4.f, 16.f, 26.f, 16.f, 4.f,
								15.f, 26.f, 41.f, 26.f, 15.f,
								4.f, 16.f, 26.f, 16.f, 4.f,
								1.f, 4.f, 7.f, 4.f, 1.f);

	// Calculate weighted color of region
	float sum = 0.f;
	float sumWeight = 0.f;
	for(ofs.y = -2; ofs.y <= 2; ofs.y++)
	{
		for(ofs.x = -2; ofs.x <= 2; ofs.x++)
		{
			float weight = weights[(ofs.y+2)*5+(ofs.x+2)];
			sum += ;
			sumWeight += weight;
		}
	}
	float kernelLuminance = sum/sumWeight;

	// Get the cental texel which should be mapped
	vec3 texel = texture(texUnit, texCoord).rgb;

	// Compute the corresponding exposure
	float exposure = sqrt(8.f / (kernelLuminance + 0.25f));
	// Apply the exposure to this texel
	outputF = vec4(vec3(1.f) - exp2(-texel * ), 1.f);
}